{
     nama : Demo menyimpan data ke Excel menggunakan Delphi 5
     
     tujuan :
           untuk menyimpan data-data ke Excel dengan menggunakan
           komponen yang telah disediakan oleh Delphi 5 di tab Servers, yaitu
           TExcelApplication, TExcelWorkbook, TExcelWorksheet

     oleh :
           Adi Nugroho
           Jurusan Fisika
           FMIPA - UGM
           Yogyakarta
           Indonesia

           sendto_adinugroho@yahoo.com
           www.geocities.com/iniwebsiteku/


     sekilas cara pakai program ini
     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     1. klik tombol "Call Excel", untuk mengaktifkan Excel
           setelah Excel berhasil dipanggil maka ada kemungkinan form program ini
           akan tertutupi oleh Excel (jika Excel aktif secara "full screen")
           solusi : agar form program ini tidak tertutup setelah memanggil Excel,
                       maka Anda dapat menjadikan agar form ini selalu diatas -- always on top --
                       yaitu dengan mengubah properti FormStyle menjadi fsStayOnTop
                       atau agar lebih fleksibel tambahkan saja CheckBox untuk mengaturnya...
     2. klik tombol "Create WBook", untuk membuat lembar kerja baru
     3. klik tombol "save as XLS", untuk menyimpan lembar kerja sebagai file Excel
     4. PageControl telah aktif, dan bisa digunakan ...
           (pilih tab Bilik 01 atau Bilik 02...terserah!!!)
     5. jika ada pelanggan yang akan memakai komputer untuk ber-internet,
           maka isikan nama pelanggan
     6. klik tombol "start", untuk mencatat waktu mulai pemakaian komputer
     7. jika pelanggan telah selesai memakai komputer, klik tombol "finish" untuk
           mencatat waktu akhir pemakaian komputer,
           kemudian menghitung lama pakai dan menghitung harga sewa yang harus dibayar.
           semua data tersebut langsung dikirim ke Excel dan disimpan (save)
     8. untuk mengakhiri program ini, maka klik tombol "Disconnect Excel" dan
           kemudian klik tombol "Exit"             

}                      

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleServer, Excel97, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ButtonCallXL: TButton;
    ButtonDisconnectXL: TButton;
    ExcelApplication1: TExcelApplication;
    ExcelWorksheet1: TExcelWorksheet;
    ExcelWorkbook1: TExcelWorkbook;
    ButtonExit: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Edit3: TEdit;
    Label3: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    LabelWaktuPakai: TLabel;
    Label15: TLabel;
    LabelBiaya: TLabel;
    ButtonMulai_01: TButton;
    ButtonSelesai_01: TButton;
    Label17: TLabel;
    EditNamaBilik1: TEdit;
    SaveDialog1: TSaveDialog;
    LabelWaktuMulai: TLabel;
    LabelWaktuSelesai: TLabel;
    Panel1: TPanel;
    Label1: TLabel;
    ButtonAbout: TButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Memo1: TMemo;
    Label2: TLabel;
    EditNamaBilik2: TEdit;
    Label4: TLabel;
    LabelWaktuMulai2: TLabel;
    Label6: TLabel;
    LabelWaktuSelesai2: TLabel;
    Label8: TLabel;
    LabelWaktuPakai2: TLabel;
    Label10: TLabel;
    LabelBiaya2: TLabel;
    ButtonMulai_02: TButton;
    ButtonSelesai_02: TButton;
    ButtonCreateWBook: TButton;
    ButtonSaveAsXL: TButton;
    Label5: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    LabelStatusBilik01: TLabel;
    LabelStatusBilik02: TLabel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    procedure ButtonCallXLClick(Sender: TObject);
    procedure ButtonDisconnectXLClick(Sender: TObject);
    procedure ButtonCreateWBookClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExcelApplication1WorkbookBeforeClose(Sender: TObject; var Wb,
      Cancel: OleVariant);
    procedure ButtonExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonMulai_01Click(Sender: TObject);
    procedure ButtonSelesai_01Click(Sender: TObject);
    procedure ButtonSaveAsXLClick(Sender: TObject);
    procedure ButtonMulai_02Click(Sender: TObject);
    procedure ButtonSelesai_02Click(Sender: TObject);
    procedure ButtonAboutClick(Sender: TObject);
  private
    { Private declarations }
    lcid : integer;
    BarisPadaExcel : integer;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses ComOBJ, ActiveX, ShellAPI;

// connect to Excel !
procedure TForm1.ButtonCallXLClick(Sender: TObject);
begin
     // panggil Excel , tapi masih tanpa lembar kerja 
     lcid := GetUserDefaultLCID;
     ExcelApplication1.Visible [lcid] := true;

     // non-aktifkan tombol ini
     ButtonCallXL.Enabled := false;

     ButtonDisconnectXL.Enabled := true;
     ButtonCreateWBook.Enabled := true;
     ButtonSaveAsXL.Enabled := true;

end;

procedure TForm1.ButtonDisconnectXLClick(Sender: TObject);
begin
     // putus hubungan dengan Excel
     ExcelApplication1.Disconnect;
     
     PageControl1.Enabled := false;
     ButtonCallXL.Enabled := true;

     ButtonDisconnectXL.Enabled := false;
     ButtonCreateWBook.Enabled := false;
     ButtonSaveAsXL.Enabled := false;
     
end;

procedure TForm1.ButtonCreateWBookClick(Sender: TObject);
begin
     // buat WorkBook sebagai penyimpan data
     ExcelWorkBook1.ConnectTo (ExcelApplication1.WorkBooks.Add (xlWBATWorksheet,lcid));
     ExcelWorkSheet1.ConnectTo (ExcelWorkBook1.WorkSheets[1] as _Worksheet);

     // buat keterangan di Excel
     ExcelWorksheet1.Cells.Item [1,1].Value := 'warNET notFAST.net';

     // lebar kolom saya atur menjadi 12
     ExcelApplication1.Columns.ColumnWidth := 12;

     // keterangan yang saya letakkan di baris kedua
     ExcelWorksheet1.Cells.Item [2,2].Value := 'Nama pelanggan';
     ExcelWorksheet1.Cells.Item [2,3].Value := 'Bilik no.';
     ExcelWorksheet1.Cells.Item [2,4].Value := 'Start at';
     ExcelWorksheet1.Cells.Item [2,5].Value := 'Finish at';
     ExcelWorksheet1.Cells.Item [2,6].Value := 'Time Duration';
     ExcelWorksheet1.Cells.Item [2,7].Value := 'Biaya sewa';
     
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     // ketika form ini sudah ditutup, putuskan semua hubungan ...
     ExcelWorksheet1.Disconnect;
     ExcelWorkbook1.Disconnect;
     ExcelApplication1.Disconnect;
end;

procedure TForm1.ExcelApplication1WorkbookBeforeClose(Sender: TObject;
  var Wb, Cancel: OleVariant);
begin
     // no warning ...
     ExcelApplication1.DisplayAlerts [lcid] := false;
end;

procedure TForm1.ButtonExitClick(Sender: TObject);
begin
     // tutup excel
     ExcelApplication1.DisplayAlerts [lcid] := false;
     ExcelApplication1.Quit;
     // ===================
     Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     // data yang di"ekspor" ke Excel dicatat mulai pada baris ke-3
     BarisPadaExcel := 3;

     PageControl1.Enabled := false;
     TabSheet1.Enabled := false;
     TabSheet2.Enabled := false;

     ButtonDisconnectXL.Enabled := false;
     ButtonCreateWBook.Enabled := false;
     ButtonSaveAsXL.Enabled := false;

end;

procedure TForm1.ButtonMulai_01Click(Sender: TObject);
begin
     // ada pelanggan yang mulai memakai komputer...
     // penghitungan dimulai dengan mencatat waktu awal pemakaian
     ButtonMulai_01.Enabled := false;
     ButtonSelesai_01.Enabled := true;
     
     LabelWaktuMulai.Caption       := TimeToStr (Now);  // waktu sekarang 
     LabelWaktuSelesai.Caption     := '00 : 00 : 00';
     LabelWaktuPakai.Caption       := '00 : 00 : 00';
     LabelBiaya.Caption            := '00000 rupiah';

     LabelStatusBilik01.Caption := '[ dipakai ]';

end;

procedure TForm1.ButtonSelesai_01Click(Sender: TObject);
var  Jam, Menit, Detik, MiliDetik : word;
     HargaSewa: Double;
begin
     // pelanggan telah selesai menggunakan komputer untuk berinternet,

     ButtonMulai_01.Enabled     := true;
     ButtonSelesai_01.Enabled   := false;

     // tulis waktu selesai...
     LabelWaktuSelesai.Caption     := TimeToStr (Now);

     // hitung selisih waktu pemakaian, yaitu waktu selesai dikurangi dengan waktu awal pemakaian
     DecodeTime (StrToTime (LabelWaktuSelesai.Caption) - StrToTime(LabelWaktuMulai.Caption),Jam,Menit,Detik, MiliDetik);
     LabelWaktuPakai.Caption       := IntToStr (jam) + ': ' +IntToStr (menit) + ': ' +IntToStr (detik) +': ' +IntToStr(milidetik);

     // hitung harga sewa yang harus dibayar pelanggan
     HargaSewa := Jam*60*StrToInt(Edit3.Text) +Menit*StrToInt(Edit3.Text) +Detik/60*StrToInt(Edit3.Text) +MiliDetik/3600*StrToInt(Edit3.Text);
     CurrencyString := 'Rp ';
     // tulis harga sewa dengan format "money"
     LabelBiaya.Caption := Format ('%m', [HargaSewa]);

     // langsung pindahkan data ke Excel
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,2].Value := EditNamaBilik1.Text;
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,3].Value := 'Bilik 01';
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,4].Value := LabelWaktuMulai.Caption;
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,5].Value := LabelWaktuSelesai.Caption;
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,6].Value := LabelWaktuPakai.Caption;
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,7].Value := LabelBiaya.Caption;

     // pindah baris, untuk data selanjutnya ...
     inc (BarisPadaExcel);

     // status bilik 
     LabelStatusBilik01.Caption := '[ kosong ]';

     // jangan lupa untuk langsung menyimpan perubahan data,
     // supaya data-data tidak hilang begitu saja... (^o^)
     ExcelApplication1.ActiveWorkbook.Save (lcid);
     
end;

procedure TForm1.ButtonSaveAsXLClick(Sender: TObject);
begin
     // simpan sebagai file Excel...
     if SaveDialog1.Execute then
           ExcelWorksheet1.SaveAs (SaveDialog1.FileName, EmptyParam);

     // aktifkan lembar pengisian pada PageControl1
     PageControl1.Enabled := true;
     TabSheet1.Enabled := true;
     TabSheet2.Enabled := true;

end;

procedure TForm1.ButtonMulai_02Click(Sender: TObject);
begin
     // ada pelanggan yang mulai memakai komputer...
     // penghitungan dimulai dengan mencatat waktu awal pemakaian
     
     ButtonMulai_02.Enabled := false;
     ButtonSelesai_02.Enabled := true;
     
     LabelWaktuMulai2.Caption       := TimeToStr (Now);
     LabelWaktuSelesai2.Caption     := '00 : 00 : 00';
     LabelWaktuPakai2.Caption       := '00 : 00 : 00';
     LabelBiaya2.Caption            := '00000 rupiah';

     LabelStatusBilik02.Caption := '[ dipakai ]';

end;

procedure TForm1.ButtonSelesai_02Click(Sender: TObject);
var  Jam, Menit, Detik, MiliDetik : word;
     HargaSewa: Double;
begin
     // pelanggan telah selesai menggunakan komputer untuk berinternet,
     
     ButtonMulai_02.Enabled     := true;
     ButtonSelesai_02.Enabled   := false;

     // tulis waktu selesai...
     LabelWaktuSelesai2.Caption     := TimeToStr (Now);

     // hitung selisih waktu pemakaian, yaitu waktu selesai dikurangi dengan waktu awal pemakaian     
     DecodeTime (StrToTime (LabelWaktuSelesai2.Caption) - StrToTime(LabelWaktuMulai2.Caption),Jam,Menit,Detik, MiliDetik);
     LabelWaktuPakai2.Caption       := IntToStr (jam) + ': ' +IntToStr (menit) + ': ' +IntToStr (detik) +': ' +IntToStr(milidetik);

     // hitung harga sewa yang harus dibayar pelanggan
     HargaSewa := Jam*60*StrToInt(Edit3.Text) +Menit*StrToInt(Edit3.Text) +Detik/60*StrToInt(Edit3.Text) +MiliDetik/3600*StrToInt(Edit3.Text);
     CurrencyString := 'Rp ';
     // tulis harga sewa dengan format "money"     
     LabelBiaya2.Caption := Format ('%m', [HargaSewa]);


     // langsung pindahkan data ke Excel
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,2].Value := EditNamaBilik2.Text;
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,3].Value := 'Bilik 02';
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,4].Value := LabelWaktuMulai2.Caption;
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,5].Value := LabelWaktuSelesai2.Caption;
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,6].Value := LabelWaktuPakai2.Caption;
     ExcelWorksheet1.Cells.Item [BarisPadaExcel,7].Value := LabelBiaya2.Caption;

     // pindah baris, untuk data selanjutnya ...
     inc (BarisPadaExcel);

     LabelStatusBilik02.Caption := '[ kosong ]';

     // jangan lupa untuk langsung menyimpan perubahan data,
     // supaya data-data tidak hilang begitu saja... (^o^)
     ExcelApplication1.ActiveWorkbook.Save (lcid);

end;

procedure TForm1.ButtonAboutClick(Sender: TObject);
begin
// hei, it's me...  (^_^)
     ShellAbout (Handle, 'Demo Menyimpan Data ke Excel',
                 '     ADI NUGROHO' +   #13#10 +
                 '     www.geocities.com/iniwebsiteku/',
                 Application.Icon.Handle);
end;

end.













